%global commit 692fbe95095baf9689fb923f96377626d536c6d6
%global shortcommit %(c=%{commit}; echo ${c:0:7})

%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

# we don't want to provide private python extension libs
%{?filter_setup:
%filter_provides_in %{python_sitearch}/.*\.so$ 
%filter_setup
}

%global srcname pyrit
# Need scapy for python3 first.
%global dopy3 0

Name:		%{srcname}
Version:	0.5.1
Release:	0.3.git%{shortcommit}%{?dist}
# OpenSSL exception
License:	GPLv3+ with exceptions
Group:		Applications/Internet
Summary:	A GPGPU-driven WPA/WPA2-PSK key cracker
URL:		https://github.com/JPaulMora/Pyrit
Source0:	https://github.com/JPaulMora/Pyrit/archive/%{commit}/%{name}-%{shortcommit}.tar.gz
# Source0:	https://github.com/JPaulMora/Pyrit/archive/v%%{version}.tar.gz
BuildRequires:  gcc
BuildRequires:	python2-devel, openssl-devel, zlib-devel, libpcap-devel
%if %{dopy3}
BuildRequires:	python3-devel, python3-sqlalchemy
%endif
# Scapy and python-sqlalchemy are needed for full testing
BuildRequires:	scapy, python2-sqlalchemy
Requires:	scapy, python2-sqlalchemy
%{?python_provide:%python_provide python2-%{srcname}}

%description
Pyrit exploits the computational power of many-core and GPGPU-platforms to
create massive databases, pre-computing part of the WPA/WPA2-PSK authentication
phase in a space-time trade-off. It is a powerful attack against one of the 
world's most used security-protocols.
Please note that this package only provides CPU support, GPUGPU support requires
CUDA or OpenCL, which have no Free Software implementations at this time.

%if %{dopy3}
%package -n python3-%{srcname}
Summary:        A GPGPU-driven WPA/WPA2-PSK key cracker
Requires:	python3-sqlalchemy
%{?python_provide:%python_provide python3-%{srcname}}

%description -n python3-%{srcname}
Pyrit exploits the computational power of many-core and GPGPU-platforms to
create massive databases, pre-computing part of the WPA/WPA2-PSK authentication
phase in a space-time trade-off. It is a powerful attack against one of the 
world's most used security-protocols.
Please note that this package only provides CPU support, GPUGPU support requires
CUDA or OpenCL, which have no Free Software implementations at this time.
%endif

%prep
%setup -q -n Pyrit-%{commit}

%build
%py2_build
%if %{dopy3}
%py3_build
%endif

%install
%py2_install
chmod 755 %{buildroot}%{python2_sitearch}/cpyrit/*.so

%if %{dopy3}
%py3_install
chmod 755 %{buildroot}%{python3_sitearch}/cpyrit/*.so
%endif

%check
# Can't do the tests in koji, the network tests fail, even against loopback
# pushd test
# export PYTHONPATH=%{buildroot}/%{python_sitearch}
# %{__python} test_pyrit.py 
# popd

%files
%license COPYING
%doc CHANGELOG README.md
%{_bindir}/%{name}
%{python2_sitearch}/*

%if %{dopy3}
%files -n python3-%{srcname}
%license COPYING
%doc CHANGELOG README.md
%{python3_sitearch}/*
%endif

%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.1-0.3.git692fbe9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.5.1-0.2.git692fbe9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Feb  4 2018 Tom Callaway <spot@fedoraproject.org> - 0.5.1-0.1.git692fbe9
- Update to git master (since upstream CANNOT FIGURE OUT HOW TO MAKE A PROPER RELEASE FOR THREE YEARS)

* Mon Jan 15 2018 Iryna Shcherbina <ishcherb@redhat.com> - 0.5.0-2
- Update Python 2 dependency declarations to new packaging standards
  (See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3)

* Tue Aug  8 2017 Tom Callaway <spot@fedoraproject.org> - 0.5.0-1
- update to 0.5.0

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-17
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-16
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Fri Jul 07 2017 Igor Gnatenko <ignatenko@redhat.com> - 0.4.0-15
- Rebuild due to bug in RPM (RHBZ #1468476)

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-13
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.4.0-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.4.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Sep  6 2011 Tom Callaway <spot@fedoraproject.org> 0.4.0-4
- disable tests

* Tue Aug 23 2011 Tom Callaway <spot@fedoraproject.org> 0.4.0-3
- fix perms on library file (0755)
- add BR: python-sqlalchemy for full test suite

* Mon Aug  8 2011 Tom Callaway <spot@fedoraproject.org> 0.4.0-2
- add CFLAGS for proper optimizations
- filter out private python extension lib
- add note to description about functionality limitations

* Tue Mar 29 2011 Tom Callaway <spot@fedoraproject.org> 0.4.0-1
- initial package
